# vim: enc=utf8 spell spelllang=ru
#

				МЕТОД

CCD проводится для каждой пары точка-отрезок, точка 
лежит на отрезке когда выполняется такое условие,

    | P - A |
det |       | == 0						(1)
    | B - A |

где AB это отрезок, а P точка. Надо сказать, что это условие принадлежности
точки всей прямой а не только отрезка, из-за чего нужно ещё одно условие,

N = A - B

S1 = (A - P) dot N
S2 = (B - P) dot N

S1 и S2 должны иметь разные знаки, т.е. S1*S2 < 0 .		(2)

Траектории заданы начальными и конечными положениями, настоящее состояние, и
состояние предыдущего шага (используется так же для интегрирования Верлета).
ABv(t) и Pv(t) выражаем вот так,

Av = A' + (A - A') * t
Bv = B' + (B - B') * t
Av = A' + (A - A') * t

Подставляем это в первое равенство, получаем квадратное уравнение, смотрим
среди его корней числа от 0 до 1, минимальное из них соответствует первому
пересечению точки и отрезка. Коэффициенты его здесь писать не буду, слишком
длинно получится. Второе условие применяем к отрезку в найденный ранее
момент времени t1 первого пересечения.

Если все условия пройдены, переходим к выталкиванию точки из отрезка и
наоборот.

Определяем расстояние от точки до прямой содержащей отрезок,

N = !(B - A)		// "!" - это операция взятия ортогонального вектора
N = N / length(N)
D = A dot N

DIST = P dot N - D
DIST = DIST * (0.5 + offset)

Расталкиваем по направлению нормали, до полного выхода + еще немного

P = P - N * DIST
A = A + N * DIST
B = B + N * DIST

В программе учитывается ещё и трение, но здесь это будет лишним.

Проблемы у этого метода похоже возникают на границах отрезков, точки иногда
проскакивают через них. Это решаемо, введением дополнительного постоянного
смещения по нормали. Есть ещё проблемы с тем, что выталкивание может породить
новую коллизию, это решается грубой силой, делаем выталкивания ещё и ещё,
пока не вытолкнем все объекты.

				УПРАВЛЕНИЕ

Указателем рисуем произвольные фигуры, зажав первую кнопку. Правой кнопкой
можно ловить вершины фигур, и тащить их.

На клавиатуре,
 
Q	- Выход
A	- Регулярный объект (твердый)
С	- Неподвижные объекты
S	- Мягкие объекты (веревки)
B	- Сгибаемые объекты
X	- Фоновый рисунок (цвет выбирается на 1,2,3)
D	- Удаление последнего добавленного объекта
T	- Остановка времени

Какого типа объект добавится можно узнать нажав любую клавишу и посмотрев
что будет напечатано в stdout.

Оптимизация не проводилась, много объектов рисовать не надо.

				АДРЕСА

Хотите помочь? пишите сюда,

email: amaora@yandex.ru
jID: amaora@jabber.ru

